    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------
    028     * Configuration.java
    029     * ------------------
    030     * (C)opyright 2002-2005, by Thomas Morgner and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner (taquera@sherito.org);
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: Configuration.java,v 1.8 2007/11/02 17:50:37 taqua Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 02-May-2003 : Initial version (TM);
    040     *
    041     */
    042
    043    package org.jfree.util;
    044
    045    import java.io.Serializable;
    046    import java.util.Enumeration;
    047    import java.util.Iterator;
    048
    049    /**
    050     * A simple query interface for a configuration.
    051     *
    052     * @author Thomas Morgner
    053     */
    054    public interface Configuration extends Serializable, Cloneable {
    055
    056        /**
    057         * Returns the configuration property with the specified key.
    058         *
    059         * @param key  the property key.
    060         *
    061         * @return the property value.
    062         */
    063        public String getConfigProperty(String key);
    064
    065        /**
    066         * Returns the configuration property with the specified key (or the
    067         * specified default value if there is no such property).
    068         * <p>
    069         * If the property is not defined in this configuration, the code will
    070         * lookup the property in the parent configuration.
    071         *
    072         * @param key  the property key.
    073         * @param defaultValue  the default value.
    074         *
    075         * @return the property value.
    076         */
    077        public String getConfigProperty(String key, String defaultValue);
    078
    079        /**
    080         * Returns all keys with the given prefix.
    081         *
    082         * @param prefix the prefix
    083         * @return the iterator containing all keys with that prefix
    084         */
    085        public Iterator findPropertyKeys(String prefix);
    086
    087        /**
    088         * Returns the configuration properties.
    089         *
    090         * @return The configuration properties.
    091         */
    092        public Enumeration getConfigProperties();
    093
    094        /**
    095         * Returns a clone of the object.
    096         *
    097         * @return A clone.
    098         *
    099         * @throws CloneNotSupportedException if cloning is not supported for some reason.
    100         */
    101        public Object clone() throws CloneNotSupportedException;
    102
    103    }